﻿using System.Windows;
using System.Windows.Input;
using System.Windows.Interactivity;
using Infragistics.Controls.Grids;

namespace FilteringXamGrid.Behaviors
{
    public class XamGridDoubleClickBehavior : Behavior<XamGrid>
    {
        private XamGrid Grid
        {
            get
            {
                return AssociatedObject as XamGrid;
            }
        }

        public ICommand ClickedCmd
        {
            get { return (ICommand)GetValue(ClickedCmdProperty); }
            set { SetValue(ClickedCmdProperty, value); }
        }

        public static readonly DependencyProperty ClickedCmdProperty = DependencyProperty.Register(
            "ClickedCmd",
            typeof(ICommand),
            typeof(XamGridDoubleClickBehavior),
            null);

        protected override void OnAttached()
        {
            base.OnAttached();

            Grid.MouseDoubleClick += GridMouseDoubleClick;

        }

        protected override void OnDetaching()
        {
            base.OnDetaching();
            Grid.MouseDoubleClick -= GridMouseDoubleClick;
        }

        void GridMouseDoubleClick(object sender, MouseButtonEventArgs e)
        {

            var fe = (FrameworkElement)e.OriginalSource;
            ClickedCmd.Execute(fe.DataContext);
        }

    }
}
