﻿// Type: Infragistics.Controls.Grids.Column
// Assembly: InfragisticsWPF4.Controls.Grids.XamGrid.v12.2, Version=12.2.20122.2151, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb
// Assembly location: C:\Program Files\Infragistics\NetAdvantage 2012.2\WPF\CLR4.0\Bin\SharedXAML\InfragisticsWPF4.Controls.Grids.XamGrid.v12.2.dll

using Infragistics;
using Infragistics.Collections;
using Infragistics.Controls.Grids.Primitives;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Threading;
using System.Windows;
using System.Windows.Data;

namespace Infragistics.Controls.Grids
{
  /// <summary>
  /// The base class for all standard column objects of the <see cref="T:Infragistics.Controls.Grids.XamGrid"/>.
  /// 
  /// </summary>
  public abstract class Column : ColumnBase, ISelectableObject
  {
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.Width"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty WidthProperty = DependencyProperty.Register("Width", typeof (ColumnWidth?), typeof (Column), new PropertyMetadata((object) null, new PropertyChangedCallback(Column.WidthChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.MinimumWidth"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty MinimumWidthProperty = DependencyProperty.Register("MinimumWidth", typeof (double), typeof (Column), new PropertyMetadata((object) 0.0, new PropertyChangedCallback(Column.MinimumWidthChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.MaximumWidth"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty MaximumWidthProperty = DependencyProperty.Register("MaximumWidth", typeof (double), typeof (Column), new PropertyMetadata((object) double.PositiveInfinity, new PropertyChangedCallback(Column.MaximumWidthChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.FooterText"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty FooterTextProperty = DependencyProperty.Register("FooterText", typeof (string), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.FooterTextChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.ValueConverter"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty ValueConverterProperty = DependencyProperty.Register("ValueConverter", typeof (IValueConverter), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.ValueConverterChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.ValueConverterParameter"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty ValueConverterParameterProperty = DependencyProperty.Register("ValueConverterParameter", typeof (object), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.ValueConverterParameterChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.GroupByItemTemplate"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty GroupByItemTemplateProperty = DependencyProperty.Register("GroupByItemTemplate", typeof (DataTemplate), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.GroupByItemTemplateChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.FirstSortDirection"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty FirstSortDirectionProperty = DependencyProperty.Register("DefaultSort", typeof (SortDirection?), typeof (Column), new PropertyMetadata((object) null, new PropertyChangedCallback(Column.FirstSortDirectionChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.HeaderTextHorizontalAlignment"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty HeaderTextHorizontalAlignmentProperty = DependencyProperty.Register("HeaderTextHorizontalAlignment", typeof (HorizontalAlignment?), typeof (Column), new PropertyMetadata((object) null, new PropertyChangedCallback(Column.HeaderTextHorizontalAlignmentChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.HeaderTextVerticalAlignment"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty HeaderTextVerticalAlignmentProperty = DependencyProperty.Register("HeaderTextVerticalAlignment", typeof (VerticalAlignment?), typeof (Column), new PropertyMetadata((object) null, new PropertyChangedCallback(Column.HeaderTextVerticalAlignmentChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.ToolTipStyle"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty ToolTipStyleProperty = DependencyProperty.Register("ToolTipStyle", typeof (Style), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.ToolTipStyleChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.ToolTipContentTemplate"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty ToolTipContentTemplateProperty = DependencyProperty.Register("TooltipContentTemplate", typeof (DataTemplate), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.ToolTipContentTemplateChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.AllowToolTips"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty AllowToolTipsProperty = DependencyProperty.Register("AllowToolTips", typeof (AllowToolTips), typeof (Column), new PropertyMetadata((object) AllowToolTips.Never, new PropertyChangedCallback(Column.AllowToolTipsChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowItemTemplate"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty AddNewRowItemTemplateProperty = DependencyProperty.Register("AddNewRowItemTemplate", typeof (DataTemplate), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.AddNewRowItemTemplateChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowEditorTemplate"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty AddNewRowEditorTemplateProperty = DependencyProperty.Register("AddNewRowEditorTemplate", typeof (DataTemplate), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.AddNewRowEditorTemplateChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowItemTemplateHorizontalContentAlignment"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty AddNewRowItemTemplateHorizontalContentAlignmentProperty = DependencyProperty.Register("AddNewRowItemTemplateHorizontalContentAlignment", typeof (HorizontalAlignment), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.AddNewRowItemTemplateHorizontalContentAlignmentChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowItemTemplateVerticalContentAlignment"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty AddNewRowItemTemplateVerticalContentAlignmentProperty = DependencyProperty.Register("AddNewRowItemTemplateVerticalContentAlignment", typeof (VerticalAlignment), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.AddNewRowItemTemplateVerticalContentAlignmentChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowEditorTemplateVerticalContentAlignment"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty AddNewRowEditorTemplateVerticalContentAlignmentProperty = DependencyProperty.Register("AddNewRowEditorTemplateVerticalContentAlignment", typeof (VerticalAlignment), typeof (Column), new PropertyMetadata((object) VerticalAlignment.Stretch, new PropertyChangedCallback(Column.AddNewRowEditorTemplateVerticalContentAlignmentChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowEditorTemplateHorizontalContentAlignment"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty AddNewRowEditorTemplateHorizontalContentAlignmentProperty = DependencyProperty.Register("AddNewRowEditorTemplateHorizontalContentAlignment", typeof (HorizontalAlignment), typeof (Column), new PropertyMetadata((object) HorizontalAlignment.Stretch, new PropertyChangedCallback(Column.AddNewRowEditorTemplateHorizontalContentAlignmentChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.MergedItemTemplate"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty MergedItemTemplateProperty = DependencyProperty.Register("MergedItemTemplate", typeof (DataTemplate), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.MergedItemTemplateChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowCellStyle"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty AddNewRowCellStyleProperty = DependencyProperty.Register("AddNewRowCellStyle", typeof (Style), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.AddNewRowCellStyleChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.GroupByRowStyle"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty GroupByRowCellStyleProperty = DependencyProperty.Register("GroupByRowCellStyle", typeof (Style), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.GroupByRowCellStyleChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.GroupByHeaderStyle"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty GroupByHeaderCellStyleProperty = DependencyProperty.Register("GroupByHeaderCellStyle", typeof (Style), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.GroupByHeaderCellStyleChanged)));
    /// <summary>
    /// Identifies the <see cref="P:Infragistics.Controls.Grids.Column.MergeCellStyle"/> dependency property.
    /// 
    /// </summary>
    public static readonly DependencyProperty MergeCellStyleProperty = DependencyProperty.Register("MergeCellStyle", typeof (Style), typeof (Column), new PropertyMetadata(new PropertyChangedCallback(Column.MergeCellStyleChanged)));
    private bool _allowCaseSensitiveSort = true;
    private bool _isFilterable = true;
    private bool _isSummable = true;
    private double _actualWidth;
    private FixedState _isFixed;
    private FixedIndicatorDirection? _fixedDirection;
    private bool _isFixable;
    private bool _isSortable;
    private bool _isSelected;
    private bool _isGroupBy;
    private HorizontalAlignment _hAlign;
    private VerticalAlignment _vAlign;
    private DataTemplate _footerTemplate;
    private object _comparer;
    private object _groupByComparer;
    private SortDirection _isSorted;
    private FilterColumnSettings _filterColumnSettings;
    private FilterOperand _defaultFilterOperand;
    private SummaryColumnSettings _summaryColumnSettings;
    private ConditionalFormatCollection _conditionalFormatCollection;
    private bool _isGroupable;
    private Column _cachedParentColumn;
    private List<Column> _cachedChildren;
    private bool _ignoreGroupByCalls;
    private string _cachedTypeName;
    private AllowToolTips _cachedAllowToolTips;
    private ColumnWidth? _cachedColumnWidth;
    private double _cachedMinimumWidth;
    private double _cachedMaximumWidth;
    private double _cachedActualWidth;

    /// <summary>
    /// Gets/sets the <see cref="T:Infragistics.Controls.Grids.ColumnWidth"/> of the <see cref="T:Infragistics.Controls.Grids.ColumnBase"/>
    /// </summary>
    [TypeConverter(typeof (NullableColumnWidthTypeConverter))]
    public virtual ColumnWidth? Width
    {
      get
      {
        return this._cachedColumnWidth;
      }
      set
      {
        this.SetValue(Column.WidthProperty, (object) value);
      }
    }

    /// <summary>
    /// Resolves the <see cref="T:Infragistics.Controls.Grids.ColumnWidth"/> that is being applied to this <see cref="T:Infragistics.Controls.Grids.Column"/>
    /// </summary>
    public virtual ColumnWidth WidthResolved
    {
      get
      {
        if (!this.Width.HasValue)
          return this.ColumnLayout.ColumnWidthResolved;
        else
          return this.Width.Value;
      }
    }

    /// <summary>
    /// Gets the Actual width of the column.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// Note: this value is only available when the column is rendered.
    /// </remarks>
    public double ActualWidth
    {
      get
      {
        return this._actualWidth;
      }
      internal set
      {
        if (this._actualWidth == value)
          return;
        this._actualWidth = value;
        this.OnPropertyChanged("ActualWidth");
      }
    }

    /// <summary>
    /// Gets/sets the minimum width the column is allowed to be.
    /// 
    /// </summary>
    public virtual double MinimumWidth
    {
      get
      {
        return this._cachedMinimumWidth;
      }
      set
      {
        this.SetValue(Column.MinimumWidthProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets/sets the maximum width the column is allowed to be.
    /// 
    /// </summary>
    public virtual double MaximumWidth
    {
      get
      {
        return this._cachedMaximumWidth;
      }
      set
      {
        this.SetValue(Column.MaximumWidthProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets/Sets the <see cref="T:System.Windows.DataTemplate"/> used to define the Content of the Footer of the <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    public DataTemplate FooterTemplate
    {
      get
      {
        return this._footerTemplate;
      }
      set
      {
        this._footerTemplate = value;
        this.OnPropertyChanged("FooterTemplate");
      }
    }

    /// <summary>
    /// Gets/Sets the text that will be displayed in the Footer.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// If the <see cref="P:Infragistics.Controls.Grids.Column.FooterTemplate"/> is set, this property will have no effect.
    /// </remarks>
    public string FooterText
    {
      get
      {
        return (string) this.GetValue(Column.FooterTextProperty);
      }
      set
      {
        this.SetValue(Column.FooterTextProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets/Sets if a <see cref="T:Infragistics.Controls.Grids.Column"/> should be unpinned or pinned to the Left or Right side of the <see cref="T:Infragistics.Controls.Grids.XamGrid"/>.
    /// 
    /// </summary>
    public FixedState IsFixed
    {
      get
      {
        return this._isFixed;
      }
      set
      {
        if (this._isFixed == value)
          return;
        this.SetFixedColumnState(value);
      }
    }

    /// <summary>
    /// Gets/Sets what side of the <see cref="T:Infragistics.Controls.Grids.XamGrid"/> should be locked to if the <see cref="P:Infragistics.Controls.Grids.Column.IsFixed"/> property is set to true.
    /// 
    /// </summary>
    [TypeConverter(typeof (NullableEnumTypeConverter<FixedIndicatorDirection>))]
    public FixedIndicatorDirection? FixedIndicatorDirection
    {
      get
      {
        return this._fixedDirection;
      }
      set
      {
        FixedIndicatorDirection? nullable1 = this._fixedDirection;
        FixedIndicatorDirection? nullable2 = value;
        if ((nullable1.GetValueOrDefault() != nullable2.GetValueOrDefault() ? 1 : (nullable1.HasValue != nullable2.HasValue ? 1 : 0)) == 0)
          return;
        this._fixedDirection = value;
        this.OnPropertyChanged("FixedIndicatorDirection");
      }
    }

    /// <summary>
    /// Resolves the actual <see cref="P:Infragistics.Controls.Grids.Column.FixedIndicatorDirection"/> of the <see cref="T:Infragistics.Controls.Grids.Column"/>
    /// </summary>
    public FixedIndicatorDirection FixedIndicatorDirectionResolved
    {
      get
      {
        if (!this.FixedIndicatorDirection.HasValue && this.ColumnLayout != null)
          return this.ColumnLayout.FixedColumnSettings.FixedIndicatorDirectionResolved;
        else
          return this.FixedIndicatorDirection.Value;
      }
    }

    /// <summary>
    /// Gets/Sets if a Column can be fixed.
    /// 
    /// </summary>
    public virtual bool IsFixable
    {
      get
      {
        if (this.ParentColumn == null && (!this.IsGroupBy || this.ColumnLayout == null || (this.ColumnLayout.Grid == null || this.ColumnLayout.Grid.GroupBySettings.GroupByOperation != GroupByOperation.MergeCells)))
          return this._isFixable;
        else
          return false;
      }
      set
      {
        if (this._isFixable == value)
          return;
        this._isFixable = value;
        this.OnPropertyChanged("IsFixable");
      }
    }

    /// <summary>
    /// Gets/Sets the <see cref="T:System.Windows.HorizontalAlignment"/> of the content of all cells in this <see cref="T:Infragistics.Controls.Grids.Column"/>
    /// </summary>
    public HorizontalAlignment HorizontalContentAlignment
    {
      get
      {
        return this._hAlign;
      }
      set
      {
        this._hAlign = value;
        this.OnPropertyChanged("HorizontalContentAlignment");
      }
    }

    /// <summary>
    /// Gets/Sets the <see cref="T:System.Windows.VerticalAlignment"/> of the content of all cells in this <see cref="T:Infragistics.Controls.Grids.Column"/>
    /// </summary>
    public VerticalAlignment VerticalContentAlignment
    {
      get
      {
        return this._vAlign;
      }
      set
      {
        this._vAlign = value;
        this.OnPropertyChanged("VerticalContentAlignment");
      }
    }

    /// <summary>
    /// Gets/Sets if a Column can be sorted.
    /// 
    /// </summary>
    public virtual bool IsSortable
    {
      get
      {
        return this._isSortable;
      }
      set
      {
        if (this._isSortable == value)
          return;
        this._isSortable = value;
        this.OnPropertyChanged("IsSortable");
      }
    }

    /// <summary>
    /// Gets/sets if a column should be sorted case sensitive.  This is only used for string columns.
    /// 
    /// </summary>
    public bool AllowCaseSensitiveSort
    {
      get
      {
        return this._allowCaseSensitiveSort;
      }
      set
      {
        if (this._allowCaseSensitiveSort == value)
          return;
        this._allowCaseSensitiveSort = value;
        this.OnPropertyChanged("AllowCaseSensitiveSort");
      }
    }

    /// <summary>
    /// Gets/sets a custom IComparer template object which will be used when sorting data.
    /// 
    /// </summary>
    public object SortComparer
    {
      get
      {
        return this._comparer;
      }
      set
      {
        if (this._comparer == value)
          return;
        this._comparer = value;
        this.ValidateSortComparer();
        this.OnPropertyChanged("SortComparer");
      }
    }

    /// <summary>
    /// Gets/Sets if a Column can be moved via the UI.
    /// 
    /// </summary>
    public virtual bool IsMovable { get; set; }

    /// <summary>
    /// Gets/Sets if a Column can be resized via the UI.
    /// 
    /// </summary>
    public virtual bool IsResizable { get; set; }

    /// <summary>
    /// Gets/sets if a column can be filtered via the UI.
    /// 
    /// </summary>
    public virtual bool IsFilterable
    {
      get
      {
        return this._isFilterable;
      }
      set
      {
        if (this._isFilterable == value)
          return;
        this._isFilterable = value;
        if (this.ColumnLayout == null)
          return;
        this.ColumnLayout.Grid.ExitEditModeInternal(true);
        this.ColumnLayout.Grid.InvalidateScrollPanel(false);
      }
    }

    /// <summary>
    /// Gets/Sets whether an item is currently selected.
    /// 
    /// </summary>
    public virtual bool IsSelected
    {
      get
      {
        return this._isSelected;
      }
      set
      {
        if (!this.SupportsActivationAndSelection)
          return;
        if (this.ColumnLayout != null)
        {
          if (value)
            this.ColumnLayout.Grid.SelectColumn(this, InvokeAction.Code);
          else
            this.ColumnLayout.Grid.UnselectColumn(this);
        }
        else
          this._isSelected = value;
      }
    }

    /// <summary>
    /// Gets / sets how the data in this column are sorted.
    /// 
    /// </summary>
    public virtual SortDirection IsSorted
    {
      get
      {
        return this._isSorted;
      }
      set
      {
        if (this._isSorted == value)
          return;
        this.SetSortedColumnState(value);
      }
    }

    /// <summary>
    /// Gets / sets if the column will show the UI for SummaryRow.
    /// 
    /// </summary>
    public virtual bool IsSummable
    {
      get
      {
        return this._isSummable;
      }
      set
      {
        if (this._isSummable == value)
          return;
        this._isSummable = value;
        if (this.ColumnLayout == null || this.ColumnLayout.Grid == null)
          return;
        this.ColumnLayout.Grid.InvalidateScrollPanel(false);
      }
    }

    /// <summary>
    /// Gets/sets whether a user can group their data by this <see cref="T:Infragistics.Controls.Grids.Column"/>
    /// </summary>
    public virtual bool IsGroupable
    {
      get
      {
        return this._isGroupable;
      }
      set
      {
        if (this._isGroupable == value)
          return;
        this._isGroupable = value;
      }
    }

    /// <summary>
    /// Gets/Sets whether the data that this <see cref="T:Infragistics.Controls.Grids.Column"/> represents should be grouped by this column.
    /// 
    /// </summary>
    public bool IsGroupBy
    {
      get
      {
        return this._isGroupBy;
      }
      set
      {
        if (this._isGroupBy == value || !this.CanBeGroupedBy)
          return;
        if (this.ColumnLayout != null)
        {
          if (value)
          {
            this.ColumnLayout.Grid.GroupBySettings.GroupByColumns.Add(this);
          }
          else
          {
            ColumnLayout columnLayout = this.ColumnLayout;
            if (columnLayout != null && columnLayout.Grid != null && (columnLayout.Grid.CurrentEditCell != null || columnLayout.Grid.CurrentEditRow != null))
              columnLayout.Grid.ExitEditMode(true);
            this.ColumnLayout.Grid.GroupBySettings.GroupByColumns.Remove(this);
          }
        }
        else
          this._isGroupBy = value;
      }
    }

    /// <summary>
    /// Gets/sets the <see cref="T:System.Windows.Data.IValueConverter"/> that will be used to display the value in the column.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// For editing purposes the <see cref="P:Infragistics.Controls.Grids.EditableColumn.EditorValueConverter"/> is used.  This <see cref="T:System.Windows.Data.IValueConverter"/> is only used for display.
    /// 
    /// </remarks>
    public IValueConverter ValueConverter
    {
      get
      {
        return (IValueConverter) this.GetValue(Column.ValueConverterProperty);
      }
      set
      {
        this.SetValue(Column.ValueConverterProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets/sets the parameter that will be used with the <see cref="P:Infragistics.Controls.Grids.Column.ValueConverter"/> property.
    /// 
    /// </summary>
    public object ValueConverterParameter
    {
      get
      {
        return this.GetValue(Column.ValueConverterParameterProperty);
      }
      set
      {
        this.SetValue(Column.ValueConverterParameterProperty, value);
      }
    }

    /// <summary>
    /// Gets/Sets the <see cref="T:System.Windows.DataTemplate"/> that will be used in a <see cref="T:Infragistics.Controls.Grids.Primitives.GroupByCell"/> when a column is grouped.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// The DataContext of the <see cref="T:Infragistics.Controls.Grids.Primitives.GroupByCell"/> will be of type <see cref="T:Infragistics.GroupByDataContext"/>.
    /// 
    /// </remarks>
    public DataTemplate GroupByItemTemplate
    {
      get
      {
        return (DataTemplate) this.GetValue(Column.GroupByItemTemplateProperty);
      }
      set
      {
        this.SetValue(Column.GroupByItemTemplateProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets/sets a custom <see cref="T:System.Collections.IEqualityComparer"/> template object which will be used when grouping data.
    /// 
    /// </summary>
    public object GroupByComparer
    {
      get
      {
        return this._groupByComparer;
      }
      set
      {
        if (this._groupByComparer == value)
          return;
        this._groupByComparer = value;
        this.ValidateGroupByComparer();
        this.OnPropertyChanged("GroupByComparer");
        if (this.ColumnLayout == null)
          return;
        this.ColumnLayout.InvalidateGroupByReset();
      }
    }

    /// <summary>
    /// Gets / Sets the <see cref="P:Infragistics.Controls.Grids.Column.SummaryColumnSettings"/> which will control behavior for this <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    public SummaryColumnSettings SummaryColumnSettings
    {
      get
      {
        if (this._summaryColumnSettings == null)
        {
          this._summaryColumnSettings = new SummaryColumnSettings(this);
          this._summaryColumnSettings.PropertyChanged += new PropertyChangedEventHandler(this.SummaryColumnSettings_PropertyChanged);
        }
        return this._summaryColumnSettings;
      }
      set
      {
        if (this._summaryColumnSettings == value)
          return;
        if (this._summaryColumnSettings != null)
          this._summaryColumnSettings.PropertyChanged -= new PropertyChangedEventHandler(this.SummaryColumnSettings_PropertyChanged);
        this._summaryColumnSettings = value;
        if (value == null)
          return;
        this._summaryColumnSettings.Column = this;
        value.RepopulateSummaryDefinitionCollection();
        this._summaryColumnSettings.PropertyChanged += new PropertyChangedEventHandler(this.SummaryColumnSettings_PropertyChanged);
      }
    }

    /// <summary>
    /// Gets / Sets the <see cref="P:Infragistics.Controls.Grids.Column.FilterColumnSettings"/> which will control behavior for this <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    public FilterColumnSettings FilterColumnSettings
    {
      get
      {
        if (this._filterColumnSettings == null)
          this._filterColumnSettings = new FilterColumnSettings(this);
        return this._filterColumnSettings;
      }
      set
      {
        if (this._filterColumnSettings == value)
          return;
        this._filterColumnSettings = value;
        if (value == null)
          return;
        this._filterColumnSettings.Column = this;
      }
    }

    /// <summary>
    /// Gets/Sets DefaultSort for a particular <see cref="T:Infragistics.Controls.Grids.Column"/>
    /// </summary>
    [TypeConverter(typeof (NullableEnumTypeConverter<SortDirection>))]
    public SortDirection? FirstSortDirection
    {
      get
      {
        return (SortDirection?) this.GetValue(Column.FirstSortDirectionProperty);
      }
      set
      {
        this.SetValue(Column.FirstSortDirectionProperty, (object) value);
      }
    }

    /// <summary>
    /// Resolves the <see cref="P:Infragistics.Controls.Grids.SortingSettingsOverride.FirstSortDirection"/> property for a particular <see cref="T:Infragistics.Controls.Grids.Column"/>
    /// </summary>
    public SortDirection FirstSortDirectionResolved
    {
      get
      {
        if (this.FirstSortDirection.HasValue)
          return this.FirstSortDirection.Value;
        if (this.ColumnLayout != null)
          return this.ColumnLayout.SortingSettings.FirstSortDirectionResolved;
        else
          return SortDirection.Ascending;
      }
    }

    /// <summary>
    /// Gets/sets  the <see cref="T:System.Windows.HorizontalAlignment"/> of the content for this <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    [TypeConverter(typeof (NullableEnumTypeConverter<HorizontalAlignment>))]
    public HorizontalAlignment? HeaderTextHorizontalAlignment
    {
      get
      {
        return (HorizontalAlignment?) this.GetValue(Column.HeaderTextHorizontalAlignmentProperty);
      }
      set
      {
        this.SetValue(Column.HeaderTextHorizontalAlignmentProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets the actual <see cref="T:System.Windows.HorizontalAlignment"/> of the content for this <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    public HorizontalAlignment HeaderTextHorizontalAlignmentResolved
    {
      get
      {
        if (this.HeaderTextHorizontalAlignment.HasValue)
          return this.HeaderTextHorizontalAlignment.Value;
        if (this.ColumnLayout != null)
          return this.ColumnLayout.HeaderTextHorizontalAlignmentResolved;
        else
          return (HorizontalAlignment) XamGrid.HeaderTextHorizontalAlignmentProperty.GetMetadata(typeof (XamGrid)).DefaultValue;
      }
    }

    /// <summary>
    /// Gets/sets  the <see cref="T:System.Windows.VerticalAlignment"/> of the content for this <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    [TypeConverter(typeof (NullableEnumTypeConverter<VerticalAlignment>))]
    public VerticalAlignment? HeaderTextVerticalAlignment
    {
      get
      {
        return (VerticalAlignment?) this.GetValue(Column.HeaderTextVerticalAlignmentProperty);
      }
      set
      {
        this.SetValue(Column.HeaderTextVerticalAlignmentProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets the actual <see cref="T:System.Windows.VerticalAlignment"/> of the content for this <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    public VerticalAlignment HeaderTextVerticalAlignmentResolved
    {
      get
      {
        if (this.HeaderTextVerticalAlignment.HasValue)
          return this.HeaderTextVerticalAlignment.Value;
        if (this.ColumnLayout != null)
          return this.ColumnLayout.HeaderTextVerticalAlignmentResolved;
        else
          return (VerticalAlignment) XamGrid.HeaderTextVerticalAlignmentProperty.GetMetadata(typeof (XamGrid)).DefaultValue;
      }
    }

    /// <summary>
    /// Get / set the <see cref="P:Infragistics.Controls.Grids.Column.ConditionalFormatCollection"/> which contains the formatting rules to be applied to this <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    [Browsable(false)]
    public ConditionalFormatCollection ConditionalFormatCollection
    {
      get
      {
        if (this._conditionalFormatCollection == null)
        {
          this._conditionalFormatCollection = new ConditionalFormatCollection();
          this._conditionalFormatCollection.CollectionChanged += new NotifyCollectionChangedEventHandler(this.ConditionalFormatCollection_CollectionChanged);
          this._conditionalFormatCollection.CollectionItemChanged += new EventHandler<EventArgs>(this.ConditionalFormatCollection_CollectionItemChanged);
          this._conditionalFormatCollection.Column = this;
        }
        return this._conditionalFormatCollection;
      }
      set
      {
        if (this._conditionalFormatCollection != null)
        {
          this._conditionalFormatCollection.CollectionChanged -= new NotifyCollectionChangedEventHandler(this.ConditionalFormatCollection_CollectionChanged);
          this._conditionalFormatCollection.CollectionItemChanged -= new EventHandler<EventArgs>(this.ConditionalFormatCollection_CollectionItemChanged);
          this._conditionalFormatCollection.Column = (Column) null;
        }
        this._conditionalFormatCollection = value;
        if (this._conditionalFormatCollection == null)
          return;
        this._conditionalFormatCollection.CollectionChanged += new NotifyCollectionChangedEventHandler(this.ConditionalFormatCollection_CollectionChanged);
        this._conditionalFormatCollection.CollectionItemChanged += new EventHandler<EventArgs>(this.ConditionalFormatCollection_CollectionItemChanged);
        this._conditionalFormatCollection.Column = this;
      }
    }

    /// <summary>
    /// Gets/Sets the <see cref="T:System.Windows.Style"/> of the <see cref="T:System.Windows.Controls.ToolTip"/> object that is displayed for this particular <see cref="T:Infragistics.Controls.Grids.Column"/>
    /// </summary>
    public Style ToolTipStyle
    {
      get
      {
        return (Style) this.GetValue(Column.ToolTipStyleProperty);
      }
      set
      {
        this.SetValue(Column.ToolTipStyleProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets/Sets the <see cref="T:System.Windows.DataTemplate"/> that should be used to display the content of a <see cref="T:Infragistics.Controls.Grids.Column"/>'s tooltip.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// The DataContext of the tooltip is the particualr Row's Data.
    /// 
    /// </remarks>
    public DataTemplate ToolTipContentTemplate
    {
      get
      {
        return (DataTemplate) this.GetValue(Column.ToolTipContentTemplateProperty);
      }
      set
      {
        this.SetValue(Column.ToolTipContentTemplateProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets/Sets when a <see cref="T:System.Windows.Controls.ToolTip"/> should be displayed for every <see cref="T:Infragistics.Controls.Grids.Cell"/> in this <see cref="T:Infragistics.Controls.Grids.Column"/>
    /// </summary>
    public AllowToolTips AllowToolTips
    {
      get
      {
        return this._cachedAllowToolTips;
      }
      set
      {
        this.SetValue(Column.AllowToolTipsProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets a ReadOnly collection of all <see cref="T:Infragistics.Controls.Grids.Column"/> objects that belong to a particular <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// This includes Columns that are children of other Columns.
    /// 
    /// </remarks>
    [Browsable(false)]
    public virtual ReadOnlyKeyedColumnBaseCollection<Column> AllColumns
    {
      get
      {
        return new ReadOnlyKeyedColumnBaseCollection<Column>((IList<Column>) new List<Column>());
      }
    }

    /// <summary>
    /// Gets a ReadOnly collection of all visible <see cref="T:Infragistics.Controls.Grids.Column"/> objects that have no children columns.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// This includes Columns that are children of other Columns.
    /// 
    /// </remarks>
    [Browsable(false)]
    public virtual ReadOnlyKeyedColumnBaseCollection<Column> AllVisibleChildColumns
    {
      get
      {
        return new ReadOnlyKeyedColumnBaseCollection<Column>((IList<Column>) new List<Column>());
      }
    }

    /// <summary>
    /// Gets / sets the <see cref="T:System.Windows.DataTemplate"/> that will be used to generate content for the <see cref="T:Infragistics.Controls.Grids.CellBase"/> of the <see cref="T:Infragistics.Controls.Grids.EditableColumn"/> in the <see cref="T:Infragistics.Controls.Grids.Primitives.AddNewRowCell"/>.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// If this property is null then the normal column content is used.
    /// 
    /// </remarks>
    public DataTemplate AddNewRowItemTemplate
    {
      get
      {
        return (DataTemplate) this.GetValue(Column.AddNewRowItemTemplateProperty);
      }
      set
      {
        this.SetValue(Column.AddNewRowItemTemplateProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets / sets the Editor that will be displayed when this <see cref="T:Infragistics.Controls.Grids.Primitives.AddNewRowCell"/> in this <see cref="T:Infragistics.Controls.Grids.EditableColumn"/> is in edit mode.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// If this property is null then the normal editor content is used.
    /// 
    /// </remarks>
    public DataTemplate AddNewRowEditorTemplate
    {
      get
      {
        return (DataTemplate) this.GetValue(Column.AddNewRowEditorTemplateProperty);
      }
      set
      {
        this.SetValue(Column.AddNewRowEditorTemplateProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets / sets the <see cref="T:System.Windows.HorizontalAlignment"/> which will be assigned to the content of the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowItemTemplate"/>.
    /// 
    /// </summary>
    public HorizontalAlignment AddNewRowItemTemplateHorizontalContentAlignment
    {
      get
      {
        return (HorizontalAlignment) this.GetValue(Column.AddNewRowItemTemplateHorizontalContentAlignmentProperty);
      }
      set
      {
        this.SetValue(Column.AddNewRowItemTemplateHorizontalContentAlignmentProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets / sets the <see cref="T:System.Windows.VerticalAlignment"/> which will be assigned to the content of the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowItemTemplate"/>.
    /// 
    /// </summary>
    public VerticalAlignment AddNewRowItemTemplateVerticalContentAlignment
    {
      get
      {
        return (VerticalAlignment) this.GetValue(Column.AddNewRowItemTemplateVerticalContentAlignmentProperty);
      }
      set
      {
        this.SetValue(Column.AddNewRowItemTemplateVerticalContentAlignmentProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets / sets the <see cref="T:System.Windows.VerticalAlignment"/> which will be assigned to the content of the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowEditorTemplate"/>.
    /// 
    /// </summary>
    public VerticalAlignment AddNewRowEditorTemplateVerticalContentAlignment
    {
      get
      {
        return (VerticalAlignment) this.GetValue(Column.AddNewRowEditorTemplateVerticalContentAlignmentProperty);
      }
      set
      {
        this.SetValue(Column.AddNewRowEditorTemplateVerticalContentAlignmentProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets / sets the <see cref="T:System.Windows.HorizontalAlignment"/> which will be assigned to the content of the <see cref="P:Infragistics.Controls.Grids.Column.AddNewRowEditorTemplate"/>.
    /// 
    /// </summary>
    public HorizontalAlignment AddNewRowEditorTemplateHorizontalContentAlignment
    {
      get
      {
        return (HorizontalAlignment) this.GetValue(Column.AddNewRowEditorTemplateHorizontalContentAlignmentProperty);
      }
      set
      {
        this.SetValue(Column.AddNewRowEditorTemplateHorizontalContentAlignmentProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets/Sets the <see cref="T:System.Windows.DataTemplate"/> that will be used in a <see cref="T:Infragistics.Controls.Grids.Primitives.MergedContentControl"/> when a column is merged.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// The DataContext of the <see cref="T:Infragistics.Controls.Grids.Primitives.MergedContentControl"/> will be of type <see cref="T:Infragistics.MergeDataContext"/>.
    /// 
    /// </remarks>
    public DataTemplate MergedItemTemplate
    {
      get
      {
        return (DataTemplate) this.GetValue(Column.MergedItemTemplateProperty);
      }
      set
      {
        this.SetValue(Column.MergedItemTemplateProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets / sets the <see cref="T:System.Windows.Style"/> which will be applied to the <see cref="T:Infragistics.Controls.Grids.Cell"/> on the <see cref="T:Infragistics.Controls.Grids.Primitives.AddNewRow"/>.
    /// 
    /// </summary>
    public Style AddNewRowCellStyle
    {
      get
      {
        return (Style) this.GetValue(Column.AddNewRowCellStyleProperty);
      }
      set
      {
        this.SetValue(Column.AddNewRowCellStyleProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets / sets the <see cref="T:System.Windows.Style"/> which will be applied to the <see cref="T:Infragistics.Controls.Grids.Cell"/> on the <see cref="T:Infragistics.Controls.Grids.Primitives.GroupByRow"/>.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// This style should target a <see cref="T:Infragistics.Controls.Grids.Primitives.GroupByCellControl"/>.
    /// 
    /// </remarks>
    public Style GroupByRowStyle
    {
      get
      {
        return (Style) this.GetValue(Column.GroupByRowCellStyleProperty);
      }
      set
      {
        this.SetValue(Column.GroupByRowCellStyleProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets / sets the <see cref="T:System.Windows.Style"/> which will be applied to the <see cref="T:Infragistics.Controls.Grids.Cell"/> on the <see cref="T:Infragistics.Controls.Grids.Primitives.GroupByRow"/>.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// This style should target a <see cref="T:Infragistics.Controls.Grids.Primitives.GroupByHeaderCellControl"/>.
    /// 
    /// </remarks>
    public Style GroupByHeaderStyle
    {
      get
      {
        return (Style) this.GetValue(Column.GroupByHeaderCellStyleProperty);
      }
      set
      {
        this.SetValue(Column.GroupByHeaderCellStyleProperty, (object) value);
      }
    }

    /// <summary>
    /// Gets / sets the <see cref="T:System.Windows.Style"/> which will be applied to the <see cref="T:Infragistics.Controls.Grids.Cell"/> for a merge cell.
    /// 
    /// </summary>
    public Style MergeCellStyle
    {
      get
      {
        return (Style) this.GetValue(Column.MergeCellStyleProperty);
      }
      set
      {
        this.SetValue(Column.MergeCellStyleProperty, (object) value);
      }
    }

    internal double PercentMoved { get; set; }

    internal double MovingColumnsWidth { get; set; }

    internal bool ReverseMove { get; set; }

    internal bool IsInitialAutoSet { get; set; }

    internal string TypeName
    {
      get
      {
        if (this._cachedTypeName == null)
          this._cachedTypeName = this.GetType().Name;
        return this._cachedTypeName;
      }
    }

    internal bool IsDragging { get; set; }

    internal bool? CachedPropertyReadOnly { get; set; }

    internal int CachedClipboardIndex { get; set; }

    /// <summary>
    /// CachedParentColumn returns the parent column stored off when a child column is temporary removed/moved
    ///             when grouping (with <see cref="P:Infragistics.Controls.Grids.GroupBySettings.GroupByOperation"/><see cref="F:Infragistics.Controls.Grids.GroupByOperation.MergeCells"/>)
    /// 
    /// </summary>
    internal Column CachedParentColumn
    {
      get
      {
        return this._cachedParentColumn;
      }
    }

    /// <summary>
    /// Gets whether a <see cref="T:Infragistics.Controls.Grids.Primitives.HeaderCell"/> or <see cref="T:Infragistics.Controls.Grids.Primitives.FooterCell"/> are allowed to display
    ///             content that's not directly set on them, such as the <see cref="P:Infragistics.Controls.Grids.XamGrid.ColumnsHeaderTemplate"/> property.
    /// 
    /// </summary>
    protected internal virtual bool SupportsHeaderFooterContent
    {
      get
      {
        return true;
      }
    }

    /// <summary>
    /// Resolves whether this <see cref="T:Infragistics.Controls.Grids.Column"/> supports editing.
    /// 
    /// </summary>
    protected internal virtual bool IsEditable
    {
      get
      {
        return false;
      }
    }

    /// <summary>
    /// Resolves whether <see cref="T:Infragistics.Controls.Grids.Cell"/> objects can be recycled and shared amongst columns of the same type.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// Note: If false, then the Cells generated by this Column's ContentProvider will be
    ///             shared between other column's of this specific type.
    /// 
    /// </remarks>
    protected internal virtual bool UniqueColumnContent
    {
      get
      {
        return false;
      }
    }

    /// <summary>
    /// The default <see cref="T:Infragistics.Controls.Grids.FilterOperand"/> for this column type;
    /// 
    /// </summary>
    protected internal virtual FilterOperand DefaultFilterOperand
    {
      get
      {
        if (this._defaultFilterOperand == null)
          this._defaultFilterOperand = (FilterOperand) new EqualsOperand();
        return this._defaultFilterOperand;
      }
    }

    /// <summary>
    /// Gets a value indicating whether filtering will be immediately applied after the value of the cell editor is changed.
    /// 
    /// </summary>
    /// 
    /// <value>
    /// <c>true</c> if a filter should be applied immediately after the value of the cell editor is changed; otherwise, <c>false</c>.
    /// 
    /// </value>
    /// 
    /// <remarks>
    /// Designed to be used by <see cref="T:Infragistics.Controls.Grids.Column"/>s which need filtering while the editor control is being edited.
    /// 
    /// </remarks>
    protected internal virtual bool AllowCellEditorValueChangedFiltering
    {
      get
      {
        return this.DataType == typeof (string);
      }
    }

    /// <summary>
    /// A format string for formatting data in this column.
    /// 
    /// </summary>
    protected internal virtual string FormatStringResolved
    {
      get
      {
        return (string) null;
      }
    }

    /// <summary>
    /// Gets/Sets the <see cref="T:Infragistics.Controls.Grids.Column"/> that owns this particular column.
    /// 
    /// </summary>
    /// 
    /// <remarks>
    /// If a Column is not a direct child of a Column, then this property will return null.
    /// </remarks>
    protected internal Column ParentColumn { get; set; }

    /// <summary>
    /// Resolves the <see cref="T:Infragistics.Controls.Grids.Column"/> that should be resized when dragging the right edge of this Column.
    /// 
    /// </summary>
    protected internal virtual Column ResizeColumnResolved
    {
      get
      {
        return this;
      }
    }

    /// <summary>
    /// Determines if a <see cref="T:Infragistics.Controls.Grids.Cell"/> in this particular Column can be Selected or Activated.
    /// 
    /// </summary>
    protected internal virtual bool SupportsActivationAndSelection
    {
      get
      {
        return true;
      }
    }

    /// <summary>
    /// Determines if a <see cref="T:Infragistics.Controls.Grids.Column"/> can be grouped by.
    /// 
    /// </summary>
    protected internal virtual bool CanBeGroupedBy
    {
      get
      {
        return true;
      }
    }

    /// <summary>
    /// Determines if a <see cref="T:Infragistics.Controls.Grids.Column"/> can be Sorted.
    /// 
    /// </summary>
    protected internal virtual bool CanBeSorted
    {
      get
      {
        return true;
      }
    }

    /// <summary>
    /// Determines if a <see cref="T:Infragistics.Controls.Grids.Column"/> can be Filtered.
    /// 
    /// </summary>
    protected internal virtual bool CanBeFiltered
    {
      get
      {
        return true;
      }
    }

    /// <summary>
    /// Determines if the <see cref="T:Infragistics.Controls.Grids.Column"/> should use the ReadOnly flag on a property, to determine if it can enter edit mode.
    /// 
    /// </summary>
    protected internal virtual bool UseReadOnlyFlag
    {
      get
      {
        return true;
      }
    }

    /// <summary>
    /// Gets if the <see cref="T:Infragistics.Controls.Grids.Column"/> should reset the CellValueObject when exiting edit mode.
    /// 
    /// </summary>
    protected internal virtual bool ResetCellValueObjectAfterEditing
    {
      get
      {
        return true;
      }
    }

    /// <summary>
    /// Gets the default string for the FilterMenu for the CustomFilter text
    /// 
    /// </summary>
    protected virtual string FilterMenuCustomFilterString
    {
      get
      {
        return SRGrid.GetString("CustomFiltersWithoutType");
      }
    }

    internal SortDirection NextSortDirection
    {
      get
      {
        SortDirection sortDirection = this.IsSorted;
        if (this.ColumnLayout != null)
          sortDirection = this.IsSorted != SortDirection.Ascending ? (this.IsSorted != SortDirection.None ? SortDirection.Ascending : this.FirstSortDirectionResolved) : SortDirection.Descending;
        return sortDirection;
      }
    }

    bool ISelectableObject.IsSelected
    {
      get
      {
        return this.IsSelected;
      }
      set
      {
        this.IsSelected = value;
      }
    }

    /// <summary>
    /// Gets a List of properties that shouldn't be saved when the PersistenceManager goes to save them.
    /// 
    /// </summary>
    protected override List<string> PropertiesToIgnore
    {
      get
      {
        List<string> propertiesToIgnore = base.PropertiesToIgnore;
        propertiesToIgnore.AddRange((IEnumerable<string>) new List<string>()
        {
          "IsGroupBy",
          "IsFixed",
          "IsSorted",
          "IsSelected"
        });
        return propertiesToIgnore;
      }
    }

    static Column()
    {
    }

    /// <summary>
    /// Initializes a new instance of the <see cref="T:Infragistics.Controls.Grids.Column"/> class.
    /// 
    /// </summary>
    protected Column()
    {
      this._isFixable = true;
      this.IsMovable = true;
      this._isSortable = true;
      this.IsResizable = true;
      this.IsGroupable = true;
      this.AddNewRowItemTemplateVerticalContentAlignment = this.VerticalContentAlignment = VerticalAlignment.Center;
      this._cachedAllowToolTips = (AllowToolTips) this.GetValue(Column.AllowToolTipsProperty);
      this._cachedColumnWidth = (ColumnWidth?) this.GetValue(Column.WidthProperty);
      this._cachedMinimumWidth = (double) this.GetValue(Column.MinimumWidthProperty);
      this._cachedMaximumWidth = (double) this.GetValue(Column.MaximumWidthProperty);
    }

    private static void WidthChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column._cachedColumnWidth = (ColumnWidth?) e.NewValue;
      column.ActualWidth = 0.0;
      column.OnPropertyChanged("Width");
    }

    private static void MinimumWidthChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column._cachedMinimumWidth = (double) e.NewValue;
      column.OnPropertyChanged("MinimumWidth");
    }

    private static void MaximumWidthChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column._cachedMaximumWidth = (double) e.NewValue;
      column.OnPropertyChanged("MaximumWidth");
    }

    private static void FooterTextChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      ((DependencyObjectNotifier) obj).OnPropertyChanged("FooterText");
    }

    private static void ValueConverterChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column.OnPropertyChanged("ValueConverter");
      if (column.ColumnLayout == null || column.ColumnLayout.Grid == null)
        return;
      column.ColumnLayout.Grid.ResetPanelRows();
    }

    private static void ValueConverterParameterChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      ((DependencyObjectNotifier) obj).OnPropertyChanged("ValueConverterParameter");
    }

    private static void GroupByItemTemplateChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      if (column.ColumnLayout != null && column.ColumnLayout.Grid != null)
        column.ColumnLayout.Grid.ResetPanelRows(true);
      column.OnPropertyChanged("GroupByItemTemplate");
    }

    private static void FirstSortDirectionChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      ((DependencyObjectNotifier) obj).OnPropertyChanged("FirstSortDirection");
    }

    private static void HeaderTextHorizontalAlignmentChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      ((DependencyObjectNotifier) obj).OnPropertyChanged("HeaderTextHorizontalAlignment");
    }

    private static void HeaderTextVerticalAlignmentChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      ((DependencyObjectNotifier) obj).OnPropertyChanged("HeaderTextVerticalAlignment");
    }

    private static void ToolTipStyleChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      ((DependencyObjectNotifier) obj).OnPropertyChanged("ToolTipStyle");
    }

    private static void ToolTipContentTemplateChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      ((DependencyObjectNotifier) obj).OnPropertyChanged("TooltipContentTemplate");
    }

    internal virtual bool ShouldAlwaysAllowToolTips(CellBase cell)
    {
      return this.AllowToolTips == AllowToolTips.Always;
    }

    private static void AllowToolTipsChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column._cachedAllowToolTips = (AllowToolTips) e.NewValue;
      column.OnPropertyChanged("AllowToolTips");
    }

    private static void AddNewRowItemTemplateChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column.OnPropertyChanged("AddNewRowItemTemplate");
      if (column.ColumnLayout == null || column.ColumnLayout.Grid == null)
        return;
      column.ColumnLayout.Grid.ResetPanelRows(true);
    }

    private static void AddNewRowEditorTemplateChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column.OnPropertyChanged("AddNewRowEditorTemplate");
      if (column.ColumnLayout == null || column.ColumnLayout.Grid == null)
        return;
      column.ColumnLayout.Grid.ResetPanelRows(true);
    }

    private static void AddNewRowItemTemplateHorizontalContentAlignmentChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column.OnPropertyChanged("AddNewRowItemTemplateHorizontalContentAlignment");
      if (column.ColumnLayout == null || column.ColumnLayout.Grid == null)
        return;
      column.ColumnLayout.Grid.ResetPanelRows(true);
    }

    private static void AddNewRowItemTemplateVerticalContentAlignmentChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column.OnPropertyChanged("AddNewRowItemTemplateVerticalContentAlignment");
      if (column.ColumnLayout == null || column.ColumnLayout.Grid == null)
        return;
      column.ColumnLayout.Grid.ResetPanelRows(true);
    }

    private static void AddNewRowEditorTemplateVerticalContentAlignmentChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      ((DependencyObjectNotifier) obj).OnPropertyChanged("AddNewRowEditorTemplateVerticalContentAlignment");
    }

    private static void AddNewRowEditorTemplateHorizontalContentAlignmentChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      ((DependencyObjectNotifier) obj).OnPropertyChanged("AddNewRowEditorTemplateHorizontalContentAlignment");
    }

    private static void MergedItemTemplateChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      if (column.ColumnLayout != null && column.ColumnLayout.Grid != null)
        column.ColumnLayout.Grid.ResetPanelRows();
      column.OnPropertyChanged("MergedItemTemplate");
    }

    private static void AddNewRowCellStyleChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column.OnStyleChanged();
      column.OnPropertyChanged("AddNewRowCellStyle");
    }

    private static void GroupByRowCellStyleChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column.OnStyleChanged();
      column.OnPropertyChanged("GroupByRowCellStyle");
    }

    private static void GroupByHeaderCellStyleChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column.OnStyleChanged();
      column.OnPropertyChanged("GroupByHeaderCellStyle");
    }

    private static void MergeCellStyleChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
    {
      Column column = (Column) obj;
      column.OnStyleChanged();
      column.OnPropertyChanged("MergeCellStyle");
    }

    /// <summary>
    /// Sets the selected state of an item.
    /// 
    /// </summary>
    /// <param propertyName="isSelected"/>
    protected internal virtual void SetSelected(bool isSelected)
    {
      this._isSelected = isSelected;
      if (this.ColumnLayout == null)
        return;
      this.ColumnLayout.Grid.InvalidateScrollPanel(false);
    }

    /// <summary>
    /// Based on the type of row that is passed in, this method generates a new <see cref="T:Infragistics.Controls.Grids.CellBase"/> object.
    /// 
    /// </summary>
    /// <param propertyName="row">The row in which the cell should be created for.</param>
    /// <returns/>
    protected internal virtual CellBase GenerateCell(RowBase row)
    {
      if (row is HeaderRow)
        return this.GenerateHeaderCell(row);
      if (row is FooterRow)
        return this.GenerateFooterCell(row);
      else
        return this.GenerateDataCell(row);
    }

    /// <summary>
    /// Returns a new instance of a <see cref="T:Infragistics.Controls.Grids.Primitives.HeaderCell"/>
    /// </summary>
    /// <param propertyName="row"/>
    /// <returns/>
    protected virtual CellBase GenerateHeaderCell(RowBase row)
    {
      return (CellBase) new HeaderCell(row, this);
    }

    /// <summary>
    /// Returns a new instance of a <see cref="T:Infragistics.Controls.Grids.Primitives.FooterCell"/>
    /// </summary>
    /// <param propertyName="row"/>
    /// <returns/>
    protected virtual CellBase GenerateFooterCell(RowBase row)
    {
      return (CellBase) new FooterCell(row, this);
    }

    /// <summary>
    /// Returns a new instance of a <see cref="T:Infragistics.Controls.Grids.Cell"/>
    /// </summary>
    /// <param propertyName="row"/>
    /// <returns/>
    protected virtual CellBase GenerateDataCell(RowBase row)
    {
      if (row.RowType == RowType.AddNewRow)
        return (CellBase) new AddNewRowCell(row, this);
      if (row.RowType == RowType.FilterRow)
        return (CellBase) new FilterRowCell(row, this);
      if (row.RowType == RowType.SummaryRow)
        return (CellBase) new SummaryRowCell(row, this);
      if (row.RowType == RowType.MergedSummaryRow)
        return (CellBase) new MergedSummaryCell(row, this);
      if (this.ColumnLayout.Grid.ConditionalFormattingSettings.AllowConditionalFormatting)
        return (CellBase) new ConditionalFormattingCell(row, this);
      else
        return (CellBase) new Cell(row, this);
    }

    /// <summary>
    /// Generates a new <see cref="T:Infragistics.Controls.Grids.Primitives.ColumnContentProviderBase"/> that will be used to generate conent for <see cref="T:Infragistics.Controls.Grids.Cell"/> objects for this <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    /// 
    /// <returns/>
    protected internal abstract ColumnContentProviderBase GenerateContentProvider();

    /// <summary>
    /// Fills the <see cref="T:Infragistics.Controls.Grids.FilterOperandCollection"/> with the operands that the column expects as filter values.
    /// 
    /// </summary>
    /// <param name="availableFilters"/>
    protected internal virtual void FillAvailableFilters(FilterOperandCollection availableFilters)
    {
      ColumnLayout columnLayout = this.ColumnLayout;
      if (columnLayout == null)
        return;
      XamGrid grid = columnLayout.Grid;
      if (grid == null)
        return;
      FilterOperandCollection operandCollection1 = availableFilters;
      EqualsOperand equalsOperand1 = new EqualsOperand();
      equalsOperand1.XamWebGrid = grid;
      EqualsOperand equalsOperand2 = equalsOperand1;
      operandCollection1.Add((FilterOperand) equalsOperand2);
      FilterOperandCollection operandCollection2 = availableFilters;
      NotEqualsOperand notEqualsOperand1 = new NotEqualsOperand();
      notEqualsOperand1.XamWebGrid = grid;
      NotEqualsOperand notEqualsOperand2 = notEqualsOperand1;
      operandCollection2.Add((FilterOperand) notEqualsOperand2);
    }

    /// <summary>
    /// Fills the <see cref="T:Infragistics.SummaryOperandCollection"/> with the operands that the column expects as summary values.
    /// 
    /// </summary>
    /// <param name="availableSummaries"/>
    protected internal virtual void FillAvailableSummaries(SummaryOperandCollection availableSummaries)
    {
      ColumnLayout columnLayout = this.ColumnLayout;
      if (columnLayout == null || columnLayout.Grid == null)
        return;
      availableSummaries.Add((SummaryOperandBase) new CountSummaryOperand());
      if (this.DataType != typeof (bool) && this.DataType != typeof (bool?))
      {
        availableSummaries.Add((SummaryOperandBase) new MaximumSummaryOperand());
        availableSummaries.Add((SummaryOperandBase) new MinimumSummaryOperand());
      }
      if (!(this.DataType == typeof (int)) && !(this.DataType == typeof (int?)) && (!(this.DataType == typeof (double)) && !(this.DataType == typeof (double?))) && (!(this.DataType == typeof (Decimal)) && !(this.DataType == typeof (Decimal?)) && (!(this.DataType == typeof (long)) && !(this.DataType == typeof (long?)))) && (!(this.DataType == typeof (float)) && !(this.DataType == typeof (float?)) && (!(this.DataType == typeof (byte)) && !(this.DataType == typeof (byte?))) && (!(this.DataType == typeof (sbyte)) && !(this.DataType == typeof (sbyte?)) && (!(this.DataType == typeof (short)) && !(this.DataType == typeof (short?))))) && (!(this.DataType == typeof (ushort)) && !(this.DataType == typeof (ushort?)) && (!(this.DataType == typeof (ulong)) && !(this.DataType == typeof (ulong?))) && (!(this.DataType == typeof (uint)) && !(this.DataType == typeof (uint?)))))
        return;
      availableSummaries.Add((SummaryOperandBase) new SumSummaryOperand());
      availableSummaries.Add((SummaryOperandBase) new AverageSummaryOperand());
    }

    /// <summary>
    /// Raises the <see cref="T:Infragistics.Controls.Grids.XamGrid"/> event notifying that the filter populating event is being fired.
    /// 
    /// </summary>
    protected internal void OnShowAvailableColumnFilterOperands()
    {
      if (this.ColumnLayout == null || this.ColumnLayout.Grid == null)
        return;
      PopulatingFiltersEventArgs args = new PopulatingFiltersEventArgs();
      args.Column = this;
      args.FilterOperands = this.FilterColumnSettings.RowFilterOperands;
      this.ColumnLayout.Grid.OnShowAvailableColumnFilterOperands(args);
    }

    /// <summary>
    /// Used to validate the <see cref="P:Infragistics.Controls.Grids.Column.SortComparer"/> can be used on this <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    protected virtual void ValidateSortComparer()
    {
      if (this._comparer == null || !(this.DataType != (Type) null))
        return;
      Type type = typeof (IComparer<>).MakeGenericType(new Type[1]
      {
        this.DataType
      });
      if (type.IsAssignableFrom(this._comparer.GetType()))
        return;
      throw new TypeLoadException(string.Format((IFormatProvider) Thread.CurrentThread.CurrentCulture, SRGrid.GetString("TypeMismatchException"), new object[2]
      {
        (object) this._comparer.GetType().Name,
        (object) type.Name
      }));
    }

    /// <summary>
    /// Used to validate the <see cref="P:Infragistics.Controls.Grids.Column.GroupByComparer"/> can be used on this <see cref="T:Infragistics.Controls.Grids.Column"/>.
    /// 
    /// </summary>
    protected virtual void ValidateGroupByComparer()
    {
      if (this._groupByComparer == null || !(this.DataType != (Type) null))
        return;
      Type type = typeof (IEqualityComparer<>).MakeGenericType(new Type[1]
      {
        this.DataType
      });
      if (type.IsAssignableFrom(this._groupByComparer.GetType()))
        return;
      throw new TypeLoadException(string.Format((IFormatProvider) Thread.CurrentThread.CurrentCulture, SRGrid.GetString("TypeMismatchException"), new object[2]
      {
        (object) this._groupByComparer.GetType().Name,
        (object) type.Name
      }));
    }

    /// <summary>
    /// If a <see cref="T:Infragistics.Controls.Grids.Column"/> owns child Columns, return the collection of Columns.
    /// 
    /// </summary>
    /// 
    /// <returns/>
    protected internal virtual CollectionBase<Column> ResolveChildColumns()
    {
      return (CollectionBase<Column>) null;
    }

    /// <summary>
    /// Changes the visibility of all subcolumns.
    /// 
    /// </summary>
    /// <param name="makeFirstVisIfCollapsed"/>
    protected internal void InvalidateVisibility(bool makeFirstVisIfCollapsed)
    {
      ReadOnlyKeyedColumnBaseCollection<Column> allColumns = this.AllColumns;
      bool flag = false;
      foreach (Column column in (ReadOnlyCollection<Column>) allColumns)
      {
        if (column.ParentColumn == this && column.Visibility == Visibility.Visible)
        {
          flag = true;
          break;
        }
      }
      if (flag)
        return;
      this.Visibility = Visibility.Collapsed;
      if (!makeFirstVisIfCollapsed || allColumns.Count <= 0)
        return;
      ((ReadOnlyCollection<Column>) allColumns)[0].Visibility = Visibility.Visible;
    }

    /// <summary>
    /// Returns a new instance of the <see cref="T:Infragistics.Controls.Grids.Primitives.SelectionControl"/> which will be used by the FilterMenu.
    /// 
    /// </summary>
    /// 
    /// <returns/>
    protected internal virtual SelectionControl GenerateFilterSelectionControl()
    {
      return (SelectionControl) new FilterSelectionControl();
    }

    /// <summary>
    /// Fills the inputted list with options for the FilterMenu control.
    /// 
    /// </summary>
    /// <param name="list"/>
    protected internal virtual void FillFilterMenuOptions(List<FilterMenuTrackingObject> list)
    {
      if (list == null)
        return;
      FilterMenuTrackingObject menuTrackingObject1 = new FilterMenuTrackingObject();
      menuTrackingObject1.Label = string.IsNullOrEmpty(this.FilterColumnSettings.FilterMenuTypeSpecificFiltersString) ? this.FilterMenuCustomFilterString : this.FilterColumnSettings.FilterMenuTypeSpecificFiltersString;
      list.Add(menuTrackingObject1);
      List<FilterMenuTrackingObject> children1 = menuTrackingObject1.Children;
      EqualsOperand equalsOperand = new EqualsOperand();
      equalsOperand.DisplayName = SRGrid.GetString("EqualsEllipsis");
      FilterMenuTrackingObject menuTrackingObject2 = new FilterMenuTrackingObject((FilterOperand) equalsOperand);
      children1.Add(menuTrackingObject2);
      List<FilterMenuTrackingObject> children2 = menuTrackingObject1.Children;
      NotEqualsOperand notEqualsOperand = new NotEqualsOperand();
      notEqualsOperand.DisplayName = SRGrid.GetString("NotEqualsEllipsis");
      FilterMenuTrackingObject menuTrackingObject3 = new FilterMenuTrackingObject((FilterOperand) notEqualsOperand);
      children2.Add(menuTrackingObject3);
    }

    internal void SetGroupBy(bool groupBy)
    {
      if (this._ignoreGroupByCalls)
        return;
      this._isGroupBy = groupBy;
      if (this.ColumnLayout == null || this.ColumnLayout.Grid == null || this.ColumnLayout.Grid.GroupBySettings.GroupByOperation != GroupByOperation.MergeCells)
        return;
      if (groupBy)
      {
        this.IsFixed = FixedState.NotFixed;
        if (this.ParentColumn != null)
        {
          Column parentColumn = this.ParentColumn;
          if (parentColumn._cachedChildren == null)
            parentColumn._cachedChildren = new List<Column>((IEnumerable<Column>) this.ParentColumn.ResolveChildColumns());
          this._cachedParentColumn = this.ParentColumn;
          ColumnLayout columnLayout = this.ColumnLayout;
          XamGrid grid = columnLayout.Grid;
          this.IsMoving = false;
          parentColumn.ResolveChildColumns().Remove(this);
          columnLayout.Columns.Add((ColumnBase) this);
          grid.ResetPanelRows();
          grid.InvalidateScrollPanel(true);
          this._ignoreGroupByCalls = true;
          grid.GroupBySettings.GroupByColumns.Remove(this);
          this._ignoreGroupByCalls = false;
          parentColumn.InvalidateVisibility(true);
        }
      }
      else if (this._cachedParentColumn != null)
      {
        ColumnLayout columnLayout = this.ColumnLayout;
        XamGrid grid = columnLayout.Grid;
        this._ignoreGroupByCalls = true;
        CollectionBase<Column> collectionBase = this._cachedParentColumn.ResolveChildColumns();
        List<Column> list = this._cachedParentColumn._cachedChildren;
        this.IsMoving = false;
        columnLayout.Columns.Remove((ColumnBase) this);
        int num = list.IndexOf(this);
        bool flag = false;
        for (int index1 = num + 1; index1 < list.Count; ++index1)
        {
          Column column = list[index1];
          int index2 = collectionBase.IndexOf(column);
          if (index2 != -1)
          {
            collectionBase.Insert(index2, this);
            flag = true;
            break;
          }
        }
        if (!flag)
          collectionBase.Add(this);
        if (this._cachedParentColumn.Visibility == Visibility.Collapsed)
          this._cachedParentColumn.Visibility = Visibility.Visible;
        if (collectionBase.Count == list.Count)
          this._cachedParentColumn._cachedChildren = (List<Column>) null;
        this._cachedParentColumn = (Column) null;
        this._ignoreGroupByCalls = false;
      }
      this.OnPropertyChanged("IsGroupBy");
    }

    internal bool SetFixedColumnState(FixedState state)
    {
      bool flag1 = false;
      if (this.IsGroupBy && this.ColumnLayout != null && (this.ColumnLayout.Grid != null && this.ColumnLayout.Grid.GroupBySettings.GroupByOperation == GroupByOperation.MergeCells))
        flag1 = true;
      if (this.ParentColumn != null || flag1)
      {
        this._isFixed = FixedState.NotFixed;
        if (state != FixedState.NotFixed)
          return false;
      }
      bool flag2 = false;
      if (this.ColumnLayout != null)
        flag2 = this.ColumnLayout.Grid.OnColumnFixedStateChanging(this, state);
      if (!flag2)
      {
        FixedState previous = this._isFixed;
        this._isFixed = state;
        if (this.ColumnLayout != null)
        {
          if (state == FixedState.Left)
          {
            this.ColumnLayout.FixedColumnSettings.FixedColumnsLeft.AddItemSilently(this);
            this.ColumnLayout.FixedColumnSettings.FixedColumnsRight.RemoveItemSilently(this);
          }
          else if (state == FixedState.NotFixed)
          {
            this.ColumnLayout.FixedColumnSettings.FixedColumnsRight.RemoveItemSilently(this);
            this.ColumnLayout.FixedColumnSettings.FixedColumnsLeft.RemoveItemSilently(this);
          }
          else if (state == FixedState.Right)
          {
            this.ColumnLayout.FixedColumnSettings.FixedColumnsRight.AddItemSilently(this);
            this.ColumnLayout.FixedColumnSettings.FixedColumnsLeft.RemoveItemSilently(this);
          }
          this.ColumnLayout.Grid.OnColumnFixedStateChanged(this, previous);
        }
        this.OnPropertyChanged("IsFixed");
      }
      return !flag2;
    }

    internal void SetSortedColumnStateSilent(SortDirection state)
    {
      if (!this.CanBeSorted)
        return;
      this._isSorted = state;
      if (this.ColumnLayout == null)
        return;
      if (state == SortDirection.Ascending)
        this.ColumnLayout.SortingSettings.SortedColumns.AddItemSilently(this);
      else if (state == SortDirection.Descending)
      {
        this.ColumnLayout.SortingSettings.SortedColumns.AddItemSilently(this);
      }
      else
      {
        if (state != SortDirection.None)
          return;
        this.ColumnLayout.SortingSettings.SortedColumns.RemoveItemSilently(this);
      }
    }

    internal void SetSortedColumnStateSilent(SortDirection state, int index)
    {
      this._isSorted = state;
      if (this.ColumnLayout == null)
        return;
      if (state == SortDirection.Ascending)
        this.ColumnLayout.SortingSettings.SortedColumns.InsertItemSilently(this, index);
      else if (state == SortDirection.Descending)
      {
        this.ColumnLayout.SortingSettings.SortedColumns.InsertItemSilently(this, index);
      }
      else
      {
        if (state != SortDirection.None)
          return;
        this.ColumnLayout.SortingSettings.SortedColumns.RemoveItemSilently(this);
      }
    }

    internal bool SetSortedColumnState(SortDirection state)
    {
      return this.SetSortedColumnStateInternally(state, false);
    }

    internal bool SetSortedColumnStateInternally(SortDirection state, bool silent)
    {
      if (!this.CanBeSorted)
        return true;
      bool flag = false;
      if (this.ColumnLayout != null)
        flag = this.ColumnLayout.Grid.OnColumnSorting(this, state);
      if (!flag)
      {
        SortDirection sortDirection = this._isSorted;
        this.SetSortedColumnStateSilent(state);
        if (!silent)
          this.OnPropertyChanged("IsSorted");
        if (this.ColumnLayout != null)
          this.ColumnLayout.Grid.OnColumnSorted(this, sortDirection);
      }
      return !flag;
    }

    internal bool SetSortedColumnStateInternally(SortDirection state, bool silent, int index)
    {
      bool flag = false;
      if (this.ColumnLayout != null)
        flag = this.ColumnLayout.Grid.OnColumnSorting(this, state);
      if (!flag)
      {
        SortDirection sortDirection = this._isSorted;
        this.SetSortedColumnStateSilent(state, index);
        if (!silent)
          this.OnPropertyChanged("IsSorted");
        if (this.ColumnLayout != null)
          this.ColumnLayout.Grid.OnColumnSorted(this, sortDirection);
      }
      return !flag;
    }

    internal bool SetSortedColumnState(SortDirection state, bool multipleColumnSort)
    {
      if (!this.CanBeSorted)
        return true;
      bool flag = false;
      ColumnLayout columnLayout = this.ColumnLayout;
      if (columnLayout != null)
        flag = columnLayout.Grid.OnColumnSorting(this, state);
      if (!flag)
      {
        SortDirection sortDirection = this._isSorted;
        SortedColumnsCollection sortedColumns = columnLayout.SortingSettings.SortedColumns;
        if (state == SortDirection.None)
        {
          sortedColumns.RemoveItemSilently(this);
        }
        else
        {
          SortingSettingsOverride sortingSettings = columnLayout.SortingSettings;
          if (!multipleColumnSort || !sortingSettings.AllowMultipleColumnSortingResolved)
          {
            sortedColumns.RemoveItemSilently(this);
            sortedColumns.ClearSilently();
            sortedColumns.AddItemSilently(this);
          }
        }
        this.SetSortedColumnStateSilent(state);
        this.OnPropertyChanged("IsSorted");
        if (this.ColumnLayout != null)
          this.ColumnLayout.Grid.OnColumnSorted(this, sortDirection);
      }
      return !flag;
    }

    internal void SetActualWidthSilently(double width)
    {
      this._actualWidth = width;
    }

    internal Column ResolveRootColumn()
    {
      Column parentColumn = this.ParentColumn;
      while (parentColumn != null && parentColumn.ParentColumn != null)
        parentColumn = parentColumn.ParentColumn;
      return parentColumn;
    }

    void ISelectableObject.SetSelected(bool isSelected)
    {
      this.SetSelected(isSelected);
    }

    /// <summary>
    /// Raised when the Visiblity of a <see cref="T:Infragistics.Controls.Grids.ColumnBase"/> has changed.
    /// 
    /// </summary>
    protected override void OnVisibilityChanged()
    {
      if (this.Visibility == Visibility.Collapsed)
      {
        this._cachedActualWidth = this._actualWidth;
        this._actualWidth = 0.0;
      }
      else
      {
        this._actualWidth = this._cachedActualWidth;
        this._cachedActualWidth = 0.0;
      }
      base.OnVisibilityChanged();
    }

    /// <summary>
    /// Raised when the DataType of the <see cref="T:Infragistics.Controls.Grids.ColumnBase"/> is changed.
    /// 
    /// </summary>
    protected override void OnDataTypeChanged()
    {
      this.SummaryColumnSettings.ValidateSummaryOperands();
      FilterColumnSettings filterColumnSettings = this.FilterColumnSettings;
      filterColumnSettings.Reset();
      filterColumnSettings.ValidateFilterMenuOperands();
      filterColumnSettings.ValidateFilterOperands();
      base.OnDataTypeChanged();
    }

    /// <summary>
    /// Raised when the a <see cref="T:Infragistics.Controls.Grids.ColumnLayout"/> is assigned or removed from this <see cref="T:Infragistics.Controls.Grids.ColumnBase"/>
    /// </summary>
    protected override void OnColumnLayoutChanged()
    {
      this.SummaryColumnSettings.ValidateSummaryOperands();
      FilterColumnSettings filterColumnSettings = this.FilterColumnSettings;
      filterColumnSettings.Reset();
      filterColumnSettings.ValidateFilterMenuOperands();
      filterColumnSettings.ValidateFilterOperands();
      base.OnColumnLayoutChanged();
    }

    private void SummaryColumnSettings_PropertyChanged(object sender, PropertyChangedEventArgs e)
    {
      switch (e.PropertyName)
      {
        case "RowDisplayLabel":
        case "FormatString":
          if (this.ColumnLayout == null)
            break;
          this.ColumnLayout.RefreshSummaryRowVisual();
          break;
        default:
          this.OnPropertyChanged("SummaryColumnSettings");
          break;
      }
    }

    private void ConditionalFormatCollection_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
    {
      this.OnPropertyChanged("ConditionalFormatCollectionCollectionChanged");
    }

    private void ConditionalFormatCollection_CollectionItemChanged(object sender, EventArgs e)
    {
      if (this.ColumnLayout == null)
        return;
      this.ColumnLayout.InvalidateConditionalFormatting();
    }
  }
}
